<xsl:transform version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xlink="http://www.w3.org/1999/xlink" >





<!-- main structure of page - start -->
<xsl:template match="hazel">
	
	<svg xmlns.svg="http://www.w3.org/2000/svg" onload="initialise(evt)">
		<script language="text/javascript">

			var newMenuRoot=parseXML(printNode(document.getElementById("NewMenu")), contextMenu);
			var moveorlink = ""; var copymoveorlink; var namerequest = "--"; var id;
			
			function initialise(evt) 
			{	contextMenu.replaceChild(newMenuRoot, contextMenu.firstChild); 
			};

		</script>
		<defs>
			<xsl:call-template name="menu"/>
		</defs>
		<g>		
			<xsl:choose>
				<xsl:when test="/*/style='network'"><xsl:call-template name="network"/></xsl:when>
				<xsl:when test="/*/style='bones'"><xsl:call-template name="bones"/></xsl:when>
				<xsl:otherwise><xsl:call-template name="graph"/></xsl:otherwise>
			</xsl:choose>
		</g>
	</svg>
</xsl:template>
<!-- main structure of page - end -->





<!-- menu - start -->
<!-- menu - main structure of menu -->
<xsl:template name="menu"> 
	<menu id="NewMenu">
		<header>normal facilities</header>
		<item display="none" onactivate="parent.alert('{concat('width', /*/width)}')">display link for debugging</item>  
		<xsl:call-template name="exitandprint"/>
		<xsl:call-template name="saveandrecover"/>
		<xsl:call-template name="switchdatabase"/>
		<xsl:call-template name="modifydatabase"/>
		<xsl:call-template name="switchstyles"/>
		<xsl:call-template name="tailorcontent"/>
		<xsl:call-template name="tailordisplay"/>
		<xsl:call-template name="helpandinform"/>
	</menu>
</xsl:template>

<!-- exiting -->
<xsl:template name="exitandprint"> 
	<item onactivate="parent.close()">e&amp;xit</item>
	<item onactivate="parent.print()">print</item>
	<separator></separator>
</xsl:template>

<!-- saving and recovering -->
<xsl:template name="saveandrecover"> 
	<xsl:call-template name="itemwithlink">
		<xsl:with-param name="textdisplayed" select="'save'"/>
		<xsl:with-param name="linkparams" select="concat('set-saved-', /*/current, '-', /*/counter)"/>
	</xsl:call-template>
	<xsl:call-template name="itemwithlink">
		<xsl:with-param name="textdisplayed" select="'recover'"/>
		<xsl:with-param name="linkparams" 
									select="concat('sets-current|saved-', /*/saved, '|', /*/current, '-', /*/counter)"/>
	</xsl:call-template>
	<separator></separator>
</xsl:template>

<!-- submenu for modifying database -->
<xsl:template name="modifydatabase"> 
	<menu>
		<header>modify database</header>
		<xsl:call-template name="itemwithlink">
			<xsl:with-param name="textdisplayed" select="'attach new component'"/>
			<xsl:with-param name="linkparams" select="concat('create-z_name_--', /*/counter)"/>
		</xsl:call-template>
		<xsl:choose>
			<xsl:when test="/*/style!='graph'">
				<xsl:call-template name="enableditemwithlink">
					<xsl:with-param name="textdisplayed" select="'attach selected component'"/>
					<xsl:with-param name="linkparams" select="concat('attach-', /*/selected, '-z_name_',
						/*/augusta[/*/level]/alice/component[identifier=/*/selected]/name, '-', /*/counter)"/>
					<xsl:with-param name="isenabled" select="/*/selected!='' and /*/selected!=/*/current and
							not(/*/augusta[/*/level]/alice[identifier=/*/current]/component[identifier=/*/selected])"/>
				</xsl:call-template>
				<xsl:call-template name="enableditemwithlink">
					<xsl:with-param name="textdisplayed" select="'detach selected component'"/>
					<xsl:with-param name="linkparams" select="concat('detach-', /*/selected, '--', /*/counter)"/>
					<xsl:with-param name="isenabled" 
							select="/*/augusta[/*/level]/alice[identifier=/*/current]/component[identifier=/*/selected]"/>
				</xsl:call-template>
				<xsl:call-template name="enableditemwithlink">
					<xsl:with-param name="textdisplayed" select="'rename selected component'"/>
					<xsl:with-param name="linkparams" select="concat('rename-z_name_', 
							/*/augusta[/*/level]/alice[identifier=/*/current]/component[identifier=/*/selected]/name,
							'--', /*/counter)"/>
					<xsl:with-param name="isenabled" 
							select="/*/augusta[/*/level]/alice[identifier=/*/current]/component[identifier=/*/selected]"/>
				</xsl:call-template>
				<xsl:call-template name="itemwithlink">
					<xsl:with-param name="textdisplayed" select="'reannotate current'"/>
					<xsl:with-param name="linkparams" select="concat('reannotate-z_annotation_', 
												/*/augusta[/*/level]/alice[identifier=/*/current]/annotation, '--', /*/counter)"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="enableditemwithlink">
					<xsl:with-param name="textdisplayed" select="'attach saved component'"/>
					<xsl:with-param name="linkparams" select="concat('attach-', /*/saved, '-z_name_-', /*/counter)"/>
					<xsl:with-param name="isenabled" select="/*/saved!='' and /*/saved!=/*/current and
								not(/*/augusta[/*/level]/alice[identifier=/*/current]/component[identifier=/*/saved])"/>
				</xsl:call-template>
				<xsl:call-template name="enableditemwithlink">
					<xsl:with-param name="textdisplayed" select="'detach saved component'"/>
					<xsl:with-param name="linkparams" select="concat('detach-', /*/saved, '--', /*/counter)"/>
					<xsl:with-param name="isenabled" 
							select="/*/augusta[/*/level]/alice[identifier=/*/current]/component[identifier=/*/saved]"/>
				</xsl:call-template>
				<xsl:call-template name="itemwithlink">
					<xsl:with-param name="textdisplayed" select="'rename saved component'"/>
					<xsl:with-param name="linkparams" select="concat('rename-z_name_', 
						/*/augusta[/*/level]/alice[identifier=/*/current]/component[identifier=/*/saved]/name,
						'--', /*/counter)"/>
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:call-template name="itemwithlink">
			<xsl:with-param name="textdisplayed" select="'retype current'"/>
			<xsl:with-param name="linkparams" select="concat('retype-z_type_', 
									/*/augusta[/*/level]/alice[identifier=/*/current]/type, '--', /*/counter)"/>
		</xsl:call-template>
	</menu>
	<separator></separator>
</xsl:template>

<!-- switching databases -->
<xsl:template name="switchdatabase"> 
	<xsl:call-template name="itemwithlink">
		<xsl:with-param name="textdisplayed" select="'switch databases'"/>
		<xsl:with-param name="linkparams" select="concat('gotodb-z_name_--', /*/counter)"/>
	</xsl:call-template>
	<separator></separator>
</xsl:template>

<!-- submenu for switching styles -->
<xsl:template name="switchstyles"> 
	<menu>
		<header>switch styles</header>
		<xsl:call-template name="enableditemwithlink">
			<xsl:with-param name="textdisplayed" select="'graph'"/>
			<xsl:with-param name="linkparams" select="concat('set-style-graph-', /*/counter)"/>
			<xsl:with-param name="isenabled" select="/*/style!='graph'"/>
		</xsl:call-template>
		<xsl:call-template name="enableditemwithlink">
			<xsl:with-param name="textdisplayed" select="'network'"/>
			<xsl:with-param name="linkparams" select="concat('set-style-network-', /*/counter)"/>
			<xsl:with-param name="isenabled" select="/*/style!='network'"/>
		</xsl:call-template>
		<xsl:call-template name="enableditemwithlink">
			<xsl:with-param name="textdisplayed" select="'bones'"/>
			<xsl:with-param name="linkparams" select="concat('sets-style|left|right-bones|', 
				/*/augusta/alice[identifier=/*/current]/composite[1]/identifier, '|', 
				/*/augusta/alice[identifier=/*/current]/composite[2]/identifier, '-', /*/counter)"/>
			<xsl:with-param name="isenabled" select="/*/style!='bones'"/>
		</xsl:call-template>
	</menu>
	<separator></separator>
</xsl:template>

<!-- submenu for tailoring content -->
<xsl:template name="tailorcontent"> 
	<menu>
		<header>tailor content</header>
		<xsl:call-template name="enableditemwithlink">
			<xsl:with-param name="textdisplayed" select="'show typed components'"/>
			<xsl:with-param name="linkparams" select="concat('set-filter-show-', /*/counter)"/>
			<xsl:with-param name="isenabled" select="/*/filter!='show'"/>
		</xsl:call-template>
		<xsl:call-template name="enableditemwithlink">
			<xsl:with-param name="textdisplayed" select="'hide typed components'"/>
			<xsl:with-param name="linkparams" select="concat('set-filter-hide-', /*/counter)"/>
			<xsl:with-param name="isenabled" select="/*/filter!='hide'"/>
		</xsl:call-template>
		<xsl:call-template name="enableditemwithlink">
			<xsl:with-param name="textdisplayed" select="'hide line annotation'"/>
			<xsl:with-param name="linkparams" select="concat('set-lineannotation-none-', /*/counter)"/>
			<xsl:with-param name="isenabled" select="/*/lineannotation!='none'"/>
		</xsl:call-template>
		<xsl:call-template name="enableditemwithlink">
			<xsl:with-param name="textdisplayed" select="'show line identifiers'"/>
			<xsl:with-param name="linkparams" select="concat('set-lineannotation-identifiers-', /*/counter)"/>
			<xsl:with-param name="isenabled" select="/*/lineannotation!='identifiers'"/>
		</xsl:call-template>
		<xsl:call-template name="enableditemwithlink">
			<xsl:with-param name="textdisplayed" select="'show line identifiers and names'"/>
			<xsl:with-param name="linkparams" select="concat('set-lineannotation-both-', /*/counter)"/>
			<xsl:with-param name="isenabled" select="/*/lineannotation!='both'"/>
		</xsl:call-template>
<!--
		<xsl:call-template name="changesearchdepth">
			<xsl:with-param name="updown" select="true()"/>
		</xsl:call-template>
		<xsl:call-template name="changesearchdepth">
			<xsl:with-param name="updown" select="false()"/>
		</xsl:call-template>
-->
	</menu>
	<separator></separator>
</xsl:template>

<!-- submenu for tailoring display -->
<xsl:template name="tailordisplay"> 
	<menu>
		<header>tailor display</header>
		<xsl:call-template name="itemwithlink">
			<xsl:with-param name="textdisplayed" select="'change back colour'"/>
			<xsl:with-param name="linkparams" select="concat('set-backcolor-z_colour_', /*/backcolor, '-', /*/counter)"/>
		</xsl:call-template>
		<xsl:call-template name="itemwithlink">
			<xsl:with-param name="textdisplayed" select="'change fore colour'"/>
			<xsl:with-param name="linkparams" select="concat('set-forecolor-z_colour_', /*/forecolor, '-', /*/counter)"/>
		</xsl:call-template>
		<xsl:call-template name="itemwithlink">
			<xsl:with-param name="textdisplayed" select="'change font colour'"/>
			<xsl:with-param name="linkparams" select="concat('set-fontcolor-z_colour_', /*/fontcolor, '-', /*/counter)"/>
		</xsl:call-template>
		<xsl:call-template name="itemwithlink">
			<xsl:with-param name="textdisplayed" select="'change line colour'"/>
			<xsl:with-param name="linkparams" select="concat('set-linecolor-z_colour_', /*/linecolor, '-', /*/counter)"/>
		</xsl:call-template>
		<xsl:call-template name="itemwithlink">
			<xsl:with-param name="textdisplayed" select="'change link colour'"/>
			<xsl:with-param name="linkparams" select="concat('set-linkcolor-z_colour_', /*/linkcolor, '-', /*/counter)"/>
		</xsl:call-template>
		<xsl:call-template name="itemwithlink">
			<xsl:with-param name="textdisplayed" select="'change typed colour'"/>
			<xsl:with-param name="linkparams" 
											select="concat('set-typedcolor-z_colour_', /*/typedcolor, '-', /*/counter)"/>
		</xsl:call-template>
		<xsl:call-template name="increaseanddecrease">
			<xsl:with-param name="display" select="'font'"/>
			<xsl:with-param name="paramname" select="'font'"/>
			<xsl:with-param name="paramvalue" select="/*/font"/>
			<xsl:with-param name="top" select="10"/>
			<xsl:with-param name="bottom" select="2"/>
		</xsl:call-template>
		<xsl:call-template name="increaseanddecrease">
			<xsl:with-param name="display" select="'scaling'"/>
			<xsl:with-param name="paramname" select="'scaling'"/>
			<xsl:with-param name="paramvalue" select="/*/scaling"/>
			<xsl:with-param name="top" select="10"/>
			<xsl:with-param name="bottom" select="0"/>
		</xsl:call-template>
		<xsl:if test="/*/style!='graph'">
			<xsl:call-template name="increaseanddecrease">
				<xsl:with-param name="display" select="'rectangle_width'"/>
				<xsl:with-param name="paramname" select="'textx'"/>
				<xsl:with-param name="paramvalue" select="/*/textx"/>
				<xsl:with-param name="top" select="100"/>
				<xsl:with-param name="bottom" select="10"/>
			</xsl:call-template>
			<xsl:call-template name="increaseanddecrease">
				<xsl:with-param name="display" select="'rectangle_radiusx'"/>
				<xsl:with-param name="paramname" select="'rx'"/>
				<xsl:with-param name="paramvalue" select="/*/rx"/>
				<xsl:with-param name="top" select="10"/>
				<xsl:with-param name="bottom" select="0"/>
			</xsl:call-template>
			<xsl:call-template name="increaseanddecrease">
				<xsl:with-param name="display" select="'rectangle_radiusy'"/>
				<xsl:with-param name="paramname" select="'ry'"/>
				<xsl:with-param name="paramvalue" select="/*/ry"/>
				<xsl:with-param name="top" select="10"/>
				<xsl:with-param name="bottom" select="0"/>
			</xsl:call-template>
		</xsl:if>
	</menu>
	<separator></separator>
</xsl:template>

<!-- helping and informing -->
<xsl:template name="helpandinform"> 
	<item target="posd" xlink:href="help.html">help</item>  
	<item xlink:href="http://www.prattens.co.uk/posd.htm">about POSD..</item>
	<item action="About" id="About">about svg viewer...</item>
	<separator></separator>
</xsl:template>

<!-- menu subroutines -->
<xsl:template name="itemwithlink">
	<xsl:param name="textdisplayed"/>
	<xsl:param name="linkparams"/>
	<xsl:variable name="link" select="concat(/*/logical, /*/width, '-', /*/height, '-', /*/user, '|', /*/database, '-')"/>
	<item target="posd" xlink:href="{concat($link, $linkparams)}"> 
		<xsl:value-of select="$textdisplayed"/>
	</item>  
</xsl:template>
<xsl:template name="enableditemwithlink">
	<xsl:param name="textdisplayed"/>
	<xsl:param name="linkparams"/>
	<xsl:param name="isenabled"/>
	<xsl:variable name="link" select="concat(/*/logical, /*/width, '-', /*/height, '-', /*/user, '|', /*/database, '-')"/>
	<xsl:choose>
		<xsl:when test="$isenabled">
			<item target="posd" xlink:href="{concat($link, $linkparams)}"> 
				<xsl:value-of select="$textdisplayed"/>
			</item>  
		</xsl:when>
		<xsl:otherwise>
			<item enabled="no" target="posd" xlink:href="{concat($link, $linkparams)}"> 
				<xsl:value-of select="$textdisplayed"/>
			</item>  
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>
<xsl:template name="increaseanddecrease">
	<xsl:param name="display"/>
	<xsl:param name="paramname"/>
	<xsl:param name="paramvalue"/>
	<xsl:param name="top"/>
	<xsl:param name="bottom"/>
	<xsl:call-template name="enableditemwithlink">
		<xsl:with-param name="textdisplayed" select="concat('increase ', $display, ' to ', ($paramvalue + 1))"/>
		<xsl:with-param name="linkparams" select="concat('set-', $paramname, '-', ($paramvalue + 1), '-')"/>
		<xsl:with-param name="isenabled" select="$paramvalue &lt; $top"/>
	</xsl:call-template>
	<xsl:call-template name="enableditemwithlink">
		<xsl:with-param name="textdisplayed" select="concat('decrease ', $display, ' to ', ($paramvalue - 1))"/>
		<xsl:with-param name="linkparams" select="concat('set-', $paramname, '-', ($paramvalue - 1), '-')"/>
		<xsl:with-param name="isenabled" select="$paramvalue &gt; $bottom"/>
	</xsl:call-template>
</xsl:template>
<xsl:template name="changesearchdepth">
	<xsl:param name="updown"/>
	<xsl:variable name="incdec">
		<xsl:choose>
			<xsl:when test="$updown"><xsl:value-of select="'increase '"/></xsl:when>
			<xsl:otherwise><xsl:value-of select="'decrease '"/></xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="paramname">
		<xsl:choose>
			<xsl:when test="/*/style='network'"><xsl:value-of select="'networksearch'"/></xsl:when>
			<xsl:when test="/*/style='bones'"><xsl:value-of select="'bonessearch'"/></xsl:when>
			<xsl:otherwise><xsl:value-of select="'graphsearch'"/></xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="paramvalue">
		<xsl:choose>
			<xsl:when test="/*/style='network' and $updown">
				<xsl:value-of select="concat
					(substring-before(/*/networksearch, 'dpum'), 'dpdpumum', substring-after(/*/networksearch, 'dpum'))"/>
			</xsl:when>
			<xsl:when test="/*/style='network' and not($updown)">
				<xsl:value-of select="concat
					(substring-before(/*/networksearch, 'dpum'), '', substring-after(/*/networksearch, 'dpum'))"/>
			</xsl:when>
			<xsl:when test="/*/style='bones' and $updown">
				<xsl:value-of select="concat
					(substring-before(/*/bonessearch, 'dpum'), 'dpdpumum', substring-after(/*/bonessearch, 'dpum'))"/>
			</xsl:when>
			<xsl:when test="/*/style='bones' and not($updown)">
				<xsl:value-of select="concat
					(substring-before(/*/bonessearch, 'dpum'), '', substring-after(/*/bonessearch, 'dpum'))"/>
			</xsl:when>
			<xsl:when test="/*/style='graph' and $updown">
				<xsl:value-of select="concat
					(substring-before(/*/graphsearch, 'd'), 'dpd', substring-after(/*/graphsearch, 'd'))"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="concat
					(substring-before(/*/graphsearch, 'dp'), '', substring-after(/*/graphsearch, 'dp'))"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="depth">
		<xsl:call-template name="countdepth">		
			<xsl:with-param name="string">
				<xsl:choose>
					<xsl:when test="/*/style='network'"><xsl:value-of select="/*/networksearch"/></xsl:when>
					<xsl:when test="/*/style='bones'"><xsl:value-of select="/*/bonessearch"/></xsl:when>
					<xsl:otherwise><xsl:value-of select="/*/graphsearch"/></xsl:otherwise>
				</xsl:choose>
			</xsl:with-param>
			<xsl:with-param name="substring">
				<xsl:choose>
					<xsl:when test="/*/style='network'"><xsl:value-of select="'dpum'"/></xsl:when>
					<xsl:when test="/*/style='bones'"><xsl:value-of select="'dpum'"/></xsl:when>
					<xsl:otherwise><xsl:value-of select="'d'"/></xsl:otherwise>
				</xsl:choose>
			</xsl:with-param>
			<xsl:with-param name="depthcount" select="0"/>
		</xsl:call-template>
	</xsl:variable>
	<xsl:variable name="newdepth">
		<xsl:choose>
			<xsl:when test="$updown"><xsl:value-of select="$depth + 1"/></xsl:when>
			<xsl:otherwise><xsl:value-of select="$depth - 1"/></xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:call-template name="enableditemwithlink">
		<xsl:with-param name="textdisplayed" select="concat($incdec, /*/style, ' search depth to ', $newdepth)"/>
		<xsl:with-param name="linkparams" select="concat('set-', $paramname, '-', $paramvalue, '-')"/>
		<xsl:with-param name="isenabled" select="($updown and $newdepth &lt; 4) or (not($updown) and $newdepth &gt; 0)"/>
	</xsl:call-template>
</xsl:template>
<xsl:template name="countdepth">
	<xsl:param name="string"/>
	<xsl:param name="substring"/>
	<xsl:param name="depthcount"/>
	<xsl:choose>
		<xsl:when test="contains($string, $substring)">
			<xsl:call-template name="countdepth">		
				<xsl:with-param name="string" 
					select="concat(substring-before($string, $substring), substring-after($string, $substring))"/>
				<xsl:with-param name="substring" select="$substring"/>
				<xsl:with-param name="depthcount" select="$depthcount + 1"/>
			</xsl:call-template>
		</xsl:when>
		<xsl:otherwise><xsl:value-of select="$depthcount"/></xsl:otherwise>
	</xsl:choose>
</xsl:template>

<!-- menu - end --> 





<!-- graph view - start -->
<!-- graph view - main structure -->
<xsl:template name="graph">
	<rect x="0px" y="0px" width="{/*/width}px" height="{/*/height}px" fill="{/*/backcolor}" stroke="none"/>
	<xsl:apply-templates mode="graph" select="/*/augusta">
		<xsl:with-param name="verticalCount" select="count(/*/augusta)"/>
	</xsl:apply-templates>
</xsl:template>

<!-- graph view - iterating over levels -->
<xsl:template mode="graph" match="/*/augusta"> 
	<xsl:param name="verticalCount"/>
	<xsl:apply-templates mode="graphnodes" select="alice">
		<xsl:with-param name="verticalCount" select="$verticalCount"/>
		<xsl:with-param name="verticalPosition" select="position()"/>
		<xsl:with-param name="horizontalCount" select="count(alice)"/>
	</xsl:apply-templates>
</xsl:template>

<!-- graph view - lines down from nodes, backgounds for nodes and identifiers of nodes -->
<xsl:template mode="graphnodes" match="alice"> 
	<xsl:param name="verticalCount"/>
	<xsl:param name="verticalPosition"/>
	<xsl:param name="horizontalCount"/>
	<xsl:variable name="x1" select="/*/width div ($horizontalCount + 1) * position()"/>
	<xsl:variable name="y1" select="(/*/height div $verticalCount div 2) * (2 * $verticalPosition - 1)"/>
	<xsl:if test="$verticalCount > $verticalPosition">
		<xsl:apply-templates mode="graphlines" select="/*/augusta[$verticalPosition + 1]/alice">
			<xsl:with-param name="verticalCount" select="$verticalCount"/>
			<xsl:with-param name="verticalPosition" select="$verticalPosition"/>
			<xsl:with-param name="horizontalPosition" select="position()"/>
			<xsl:with-param name="lowerCount" select="count(/*/augusta[$verticalPosition + 1]/alice)"/>
			<xsl:with-param name="x1" select="$x1"/>
			<xsl:with-param name="y1" select="$y1"/>	
		</xsl:apply-templates>
	</xsl:if>
	<xsl:choose>
		<xsl:when test="not(type) or type=''">
			<circle cx="{$x1}px" cy="{$y1}px" r="{3 * /*/font div 2}px" fill="{/*/backcolor}" stroke="none"/>
		</xsl:when>
		<xsl:otherwise>
			<circle cx="{$x1}px" cy="{$y1}px" r="{2 * /*/font}px" fill="{/*/typedcolor}" stroke="none"/>
		</xsl:otherwise>
	</xsl:choose>
	<xsl:variable name="linkstart" select="concat(/*/logical, /*/width, '-', /*/height, '-')"/>
	<xsl:variable name="link" 
		select="concat($linkstart, /*/user, '|', /*/database, '-set-current-', identifier, '-', /*/counter)"/>
	<text font-size="{/*/font}pt" x="{$x1}px" y="{$y1 + /*/font div 2}px" 
			stroke="{/*/linkcolor}" text-anchor="middle">
		<a xlink:href="{$link}"><xsl:value-of select="identifier"/></a>
	</text>
</xsl:template>

<!-- graph view - lines and text on lines -->
<xsl:template mode="graphlines" match="/*/augusta/alice"> 
	<xsl:param name="verticalCount"/>
	<xsl:param name="verticalPosition"/>
	<xsl:param name="horizontalPosition"/>
	<xsl:param name="lowerCount"/>
	<xsl:param name="x1"/>
	<xsl:param name="y1"/>
	<xsl:variable name="id" select="identifier"/>
	<xsl:variable name="text" 
			select="/*/augusta[$verticalPosition]/alice[$horizontalPosition]/component[identifier=$id]/name"/>
	<xsl:variable name="x2" select="/*/width div ($lowerCount + 1) * position()"/>
	<xsl:variable name="y2" select="(/*/height div $verticalCount div 2) * (2 * $verticalPosition + 1)"/>
	<xsl:variable name="linename" select="concat($x1, 'x', $y1, 'x', $x2, 'x', $y2)"/>
	<xsl:variable name="transform" select="concat('rotate(180,', ($x1 + $x2) div 2, ', ', ($y1 + $y2) div 2, ')')"/>
	<path id="line{$linename}" stroke="{/*/linecolor}" d="M {$x1} {$y1} {$x2} {$y2}"/>
	<xsl:if test="/*/augusta[$verticalPosition]/alice[$horizontalPosition]/component[identifier=$id]">
		<xsl:choose>
			<xsl:when test="$x1 >= $x2">
				<text font-size="{/*/font}pt" text-anchor="start" transform="{$transform}" stroke="{/*/fontcolor}"> 
					<textPath xlink:href="#line{$linename}" startOffset="10%"><xsl:value-of select="$text"/></textPath>
				</text>
			</xsl:when>
			<xsl:otherwise>
				<text font-size="{/*/font}pt" text-anchor="end" stroke="{/*/fontcolor}">
					<textPath xlink:href="#line{$linename}" startOffset="90%"><xsl:value-of select="$text"/></textPath>
				</text>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:if>
</xsl:template>
<!-- graph view - end -->





<!-- network view - start -->
<!-- network view - main structure -->
<xsl:template name="network"> 
	<xsl:call-template name="networkframework"/>
	<xsl:apply-templates mode="headers" select="augusta[2]/alice[identifier=/*/current]/composite">
		<xsl:with-param name="level" select="1"/>
		<xsl:with-param name="down" select="23"/>
		<xsl:with-param name="style" select="'network'"/>
	</xsl:apply-templates>
	<xsl:apply-templates mode="networklines" select="augusta[3]/alice[composite/identifier=/*/current]">
	</xsl:apply-templates>
	<xsl:apply-templates mode="boxinside" select="augusta[3]/alice[composite/identifier=/*/current]">
		<xsl:with-param name="parentlevel" select="2"/>
		<xsl:with-param name="style" select="'network'"/>
	</xsl:apply-templates>
	<xsl:apply-templates mode="networkboxesout" select="augusta[3]/alice[not(composite/identifier=/*/current)]">
	</xsl:apply-templates>
</xsl:template>

<!-- network view - framework - background and box for current system -->
<xsl:template name="networkframework">
	<xsl:variable name="dw" select="width div 100"/>
	<xsl:variable name="dh" select="height div 100"/>
	<xsl:variable name="linkstart" select="concat(/*/logical, /*/width, '-', /*/height, '-')"/>
	<xsl:variable name="movelink" select="concat($linkstart, /*/user, '|', /*/database, '-')"/>
	<rect id="back" x="0px" y="0px" width="{/*/width}px" height="{/*/height}px" fill="{/*/backcolor}" 
			stroke="none" pointer-events="none"
			onmouseup="document.getElementById('back').style.setProperty('pointer-events', 'none'); 
						copymoveorlink = moveorlink; moveorlink = '';
						parent.open('{$movelink}' + copymoveorlink + '-network|' + id + '|'  
										+ '|' + evt.clientX  + '|' + evt.clientY + '--' + {/*/counter}, 'posd');" 
			onmousedown="document.getElementById('back').style.setProperty('pointer-events', 'none');"/>
	<text font-size="{/*/font}pt" x="{50*$dw}px" y="{23*$dh div 2}px" text-anchor="middle" 
			stroke="{/*/fontcolor}" pointer-events="none">
		<xsl:value-of select="/*/current"/>
	</text>
	<rect id="frame" x="{20*$dw}px" y="{12*$dh}px" width="{60*$dw}px" height="{84*$dh}px" fill="none" 
			stroke-width="3px" pointer-events="none"
			onmouseup="document.getElementById('frame').style.setProperty('pointer-events', 'none'); 
						copymoveorlink = moveorlink; moveorlink = '';
						parent.open('{$movelink}' + copymoveorlink + '-network|' + id + '|'  
										+ '|' + evt.clientX  + '|' + evt.clientY + '--' + {/*/counter}, 'posd');" 
			onmousedown="document.getElementById('frame').style.setProperty('pointer-events', 'none');">
		<xsl:attribute name="stroke">
			<xsl:choose>
				<xsl:when test="augusta[2]/alice[identifier=/*/current]/type != ''">
					<xsl:value-of select="/*/typedcolor"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="/*/linecolor"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:attribute>
	</rect>
</xsl:template>

<!-- network view - lines -->
<xsl:template mode="networklines" match="/*/augusta/alice"> 
	<xsl:variable name="x1">
		<xsl:call-template name="xin">
			<xsl:with-param name="index" select="position()"/>
			<xsl:with-param name="userdefined" select="position[type='network' and identifier=/*/current]/x"/>
		</xsl:call-template>
	</xsl:variable>
	<xsl:variable name="y1">
		<xsl:call-template name="yin">
			<xsl:with-param name="index" select="position()"/>
			<xsl:with-param name="userdefined" select="position[type='network' and identifier=/*/current]/y"/>
		</xsl:call-template>
	</xsl:variable>
	<xsl:apply-templates mode="lineinside" select="/*/augusta[3]/alice[composite/identifier=/*/current]">
		<xsl:with-param name="x1" select="$x1"/>
		<xsl:with-param name="y1" select="$y1"/>
		<xsl:with-param name="i" select="position()"/>
		<xsl:with-param name="parentlevel" select="3"/>
		<xsl:with-param name="style" select="'network'"/>
	</xsl:apply-templates>
	<xsl:apply-templates mode="networklineoutside" select="/*/augusta[3]/alice[not(composite/identifier=/*/current)]">
		<xsl:with-param name="x1" select="$x1"/>
		<xsl:with-param name="y1" select="$y1"/>
		<xsl:with-param name="i" select="position()"/>
	</xsl:apply-templates>
</xsl:template>

<!-- network view - non component boxes -->
<xsl:template mode="networkboxesout" match="/*/augusta/alice"> 
	<xsl:variable name="id" select="identifier"/>
	<xsl:call-template name="box">
		<xsl:with-param name="x">
			<xsl:call-template name="xout">
				<xsl:with-param name="index" select="position()"/>
				<xsl:with-param name="userdefined" select="''"/>
			</xsl:call-template>
		</xsl:with-param>
		<xsl:with-param name="y">
		<xsl:call-template name="yout">
			<xsl:with-param name="index" select="position()"/>
			<xsl:with-param name="userdefined" select="position[type='network' and identifier=/*/current]/y"/>
		</xsl:call-template>
		</xsl:with-param>
		<xsl:with-param name="ident" select="identifier"/>
		<xsl:with-param name="content" select="/*/augusta[2]/alice/component[identifier=$id]/name"/>
		<xsl:with-param name="containingarea" select="'back'"/>
		<xsl:with-param name="style" select="'network'"/>
		<xsl:with-param name="hasedge" select="true()"/>
		<xsl:with-param name="istyped" select="type!=''"/>
		<xsl:with-param name="hasarrow" select="/*/augusta[2]/alice/component[identifier=$id]"/>
	</xsl:call-template>
</xsl:template>

<!-- network view - non component lines -->
<xsl:template mode="networklineoutside" match="/*/augusta/alice"> 
	<xsl:param name="x1"/>
	<xsl:param name="y1"/>
	<xsl:param name="i"/>
	<xsl:variable name="p" select="position()"/>
	<xsl:call-template name="line">
		<xsl:with-param name="x1" select="$x1"/>
		<xsl:with-param name="y1" select="$y1"/>
		<xsl:with-param name="x2">
			<xsl:call-template name="xout">
				<xsl:with-param name="index" select="$p"/>
				<xsl:with-param name="userdefined" select="''"/>
			</xsl:call-template>
		</xsl:with-param>
		<xsl:with-param name="y2">
			<xsl:call-template name="yout">
				<xsl:with-param name="index" select="$p"/>
				<xsl:with-param name="userdefined" select="position[type='network' and identifier=/*/current]/y"/>
			</xsl:call-template>
		</xsl:with-param>
		<xsl:with-param name="ident1" select="/*/augusta[3]/alice[composite/identifier=/*/current][$i]/identifier"/>
		<xsl:with-param name="ident2" select="/*/augusta[3]/alice[not(composite/identifier=/*/current)][$p]/identifier"/>
		<xsl:with-param name="level" select="'4'"/>
	</xsl:call-template>
</xsl:template>

<!-- network view - end -->





<!-- bones view - start -->
<!-- bones view - main structure -->
<xsl:template name="bones"> 
	<xsl:call-template name="bonesframework"/>
	<xsl:apply-templates mode="headers" select="augusta[2]/alice[identifier=/*/current]/composite">
		<xsl:with-param name="level" select="1"/>
		<xsl:with-param name="down" select="27"/>
		<xsl:with-param name="style" select="'bones'"/>
	</xsl:apply-templates>
	<xsl:apply-templates mode="boneslines" select="augusta[3]/alice[composite/identifier=/*/current]">
	</xsl:apply-templates>
	<xsl:apply-templates mode="boxinside" select="augusta[3]/alice[composite/identifier=/*/current]">
		<xsl:with-param name="parentlevel" select="2"/>
		<xsl:with-param name="style" select="'bones'"/>
	</xsl:apply-templates>
	<xsl:apply-templates mode="bonesboxoutside" select="augusta[2]/alice
			[identifier!=/*/current and not(composite/identifier=/*/current) and composite/identifier=/*/left]">
		<xsl:with-param name="ident" select="/*/left"/>
		<xsl:with-param name="side" select="'left'"/>
		<xsl:with-param name="x" select="12 * /*/width div 100"/>
	</xsl:apply-templates>
	<xsl:apply-templates mode="bonesboxoutside" select="augusta[2]/alice
			[identifier!=/*/current and not(composite/identifier=/*/current) and composite/identifier=/*/right]">
		<xsl:with-param name="ident" select="/*/right"/>
		<xsl:with-param name="side" select="'right'"/>
		<xsl:with-param name="x" select="88 * /*/width div 100"/>
	</xsl:apply-templates>
</xsl:template>

<!-- bones view - framework - background and boxes for left, current and right systems -->
<xsl:template name="bonesframework">
	<xsl:variable name="dw" select="width div 100"/>
	<xsl:variable name="dh" select="height div 100"/>
	<xsl:variable name="linkstart" select="concat(/*/logical, /*/width, '-', /*/height, '-')"/>
	<xsl:variable name="movelink" select="concat($linkstart, /*/user, '|', /*/database, '-')"/>
	<rect id="back" x="0px" y="0px" width="{/*/width}px" height="{/*/height}px" fill="{/*/backcolor}" 
			stroke="none" pointer-events="none"/>
	<text font-size="{/*/font}pt" x="{13*$dw}px" y="{19*$dh div 2}px" text-anchor="middle" 
			stroke="{/*/fontcolor}" pointer-events="none">
		<xsl:value-of select="/*/left"/>
	</text>
	<path id="left" d="M {2*$dw} {10*$dh} {25*$dw} {10*$dh} {25*$dw} {98*$dh} {2*$dw} {98*$dh}" 
			fill="none" stroke="{/*/linecolor}" stroke-width="3px"
			onmouseup="document.getElementById('left').style.setProperty('pointer-events', 'none'); 
						copymoveorlink = moveorlink; moveorlink = '';
						parent.open('{$movelink}' + copymoveorlink + '-bones|' + id + '|'  
										+ '|' + evt.clientX  + '|' + evt.clientY + '--' + {/*/counter}, 'posd');" 
			onmousedown="document.getElementById('left').style.setProperty('pointer-events', 'none');"/>
	<text font-size="{/*/font}pt" x="{50*$dw}px" y="{27*$dh div 2}px" text-anchor="middle" 
			stroke="{/*/fontcolor}" pointer-events="none">
		<xsl:value-of select="/*/current"/>
	</text>
	<rect id="frame" x="{25*$dw}px" y="{14*$dh}px" width="{50*$dw}px" height="{80*$dh}px"
			 fill="none" stroke="{/*/linecolor}" stroke-width="3px"
			onmouseup="document.getElementById('frame').style.setProperty('pointer-events', 'none'); 
						copymoveorlink = moveorlink; moveorlink = '';
						parent.open('{$movelink}' + copymoveorlink + '-bones|' + id + '|'  
										+ '|' + evt.clientX  + '|' + evt.clientY + '--' + {/*/counter}, 'posd');" 
			onmousedown="document.getElementById('frame').style.setProperty('pointer-events', 'none');"/>
	<text font-size="{/*/font}pt" x="{87*$dw}px" y="{19*$dh div 2}px" text-anchor="middle" 
			stroke="{/*/fontcolor}" pointer-events="none">
		<xsl:value-of select="/*/right"/>
	</text>
	<path id="right" d="M {98*$dw} {98*$dh} {75*$dw} {98*$dh} {75*$dw} {10*$dh} {98*$dw} {10*$dh}" 
			fill="none" stroke="{/*/linecolor}" stroke-width="3px"
			onmouseup="document.getElementById('right').style.setProperty('pointer-events', 'none'); 
						copymoveorlink = moveorlink; moveorlink = '';
						parent.open('{$movelink}' + copymoveorlink + '-bones|' + id + '|'  
										+ '|' + evt.clientX  + '|' + evt.clientY + '--' + {/*/counter}, 'posd');" 
			onmousedown="document.getElementById('right').style.setProperty('pointer-events', 'none');"/>
</xsl:template>

<!-- bones view - lines -->
<xsl:template mode="boneslines" match="/*/augusta/alice"> 
	<xsl:variable name="x1">
		<xsl:call-template name="xin">
			<xsl:with-param name="index" select="position()"/>
			<xsl:with-param name="userdefined" select="position[type='bones' and identifier=/*/current]/x"/>
		</xsl:call-template>
	</xsl:variable>
	<xsl:variable name="y1">
		<xsl:call-template name="yin">
			<xsl:with-param name="index" select="position()"/>
			<xsl:with-param name="userdefined" select="position[type='bones' and identifier=/*/current]/y"/>
		</xsl:call-template>
	</xsl:variable>
	<xsl:apply-templates mode="lineinside" select="/*/augusta[3]/alice[composite/identifier=/*/current]">
		<xsl:with-param name="x1" select="$x1"/>
		<xsl:with-param name="y1" select="$y1"/>
		<xsl:with-param name="i" select="position()"/>
		<xsl:with-param name="parentlevel" select="3"/>
		<xsl:with-param name="style" select="'bones'"/>
	</xsl:apply-templates>
	<xsl:apply-templates mode="boneslineoutside" select="/*/augusta[2]/alice
			[identifier!=/*/current and not(composite/identifier=/*/current) and composite/identifier=/*/left]">
		<xsl:with-param name="x1" select="$x1"/>
		<xsl:with-param name="y1" select="$y1"/>
		<xsl:with-param name="i" select="position()"/>
		<xsl:with-param name="side" select="/*/left"/>
		<xsl:with-param name="x2" select="12 * /*/width div 100"/>
	</xsl:apply-templates>
	<xsl:apply-templates mode="boneslineoutside" select="/*/augusta[2]/alice
			[identifier!=/*/current and not(composite/identifier=/*/current) and composite/identifier=/*/right]">
		<xsl:with-param name="x1" select="$x1"/>
		<xsl:with-param name="y1" select="$y1"/>
		<xsl:with-param name="i" select="position()"/>
		<xsl:with-param name="side" select="/*/right"/>
		<xsl:with-param name="x2" select="88 * /*/width div 100"/>
	</xsl:apply-templates>
</xsl:template>

<!-- bones view - non component boxes -->
<xsl:template mode="bonesboxoutside" match="/*/augusta/alice"> 
	<xsl:param name="ident"/>
	<xsl:param name="side"/>
	<xsl:param name="x"/>
	<xsl:variable name="id" select="identifier"/>
	<xsl:call-template name="box">
		<xsl:with-param name="x" select="$x"/>
		<xsl:with-param name="y">
			<xsl:call-template name="yout">
				<xsl:with-param name="index" select="(34 - 2 * position()) mod 17"/>
				<xsl:with-param name="userdefined" select="position[type='bones' and identifier=/*/current]/y"/>
			</xsl:call-template>
		</xsl:with-param>
		<xsl:with-param name="ident" select="identifier"/>
		<xsl:with-param name="content" select="/*/augusta[1]/alice[identifier=$ident]/component[identifier=$id]/name"/>
		<xsl:with-param name="containingarea" select="$side"/>
		<xsl:with-param name="style" select="'bones'"/>
		<xsl:with-param name="hasedge" select="true()"/>
		<xsl:with-param name="istyped" select="type!=''"/>
		<xsl:with-param name="hasarrow" select="''"/>
	</xsl:call-template>
</xsl:template>

<!-- bones view - non component lines -->
<xsl:template mode="boneslineoutside" match="/*/augusta/alice"> 
	<xsl:param name="x1"/>
	<xsl:param name="y1"/>
	<xsl:param name="i"/>
	<xsl:param name="side"/>
	<xsl:param name="x2"/>
	<xsl:variable name="p" select="position()"/>
	<xsl:call-template name="line">
		<xsl:with-param name="x1" select="$x1"/>
		<xsl:with-param name="y1" select="$y1"/>
		<xsl:with-param name="x2" select="$x2"/>
		<xsl:with-param name="y2">
			<xsl:call-template name="yout">
				<xsl:with-param name="index" select="(34 - 2 * position()) mod 17"/>
				<xsl:with-param name="userdefined" select="position[type='bones' and identifier=/*/current]/y"/>
			</xsl:call-template>
		</xsl:with-param>
		<xsl:with-param name="ident1" select="/*/augusta[3]/alice[composite/identifier=/*/current][$i]/identifier"/>
		<xsl:with-param name="ident2" select="/*/augusta[2]/alice 
		[identifier!=/*/current and not(composite/identifier=/*/current) and composite/identifier=$side][$p]/identifier"/>
		<xsl:with-param name="level" select="'3'"/>
	</xsl:call-template>
</xsl:template>

<!-- bones view - end -->





<!-- shared capabilities -->
<!-- headers - arrow up & current identifier & link to composite & name of current within composite -->
<xsl:template mode="headers" match="/*/augusta/alice/composite"> 
	<xsl:param name="level"/>
	<xsl:param name="down"/>
	<xsl:param name="style"/>
	<xsl:variable name="dw" select="/*/width div 100"/>
	<xsl:variable name="dh" select="/*/height div 100"/>
	<xsl:variable name="x">
		<xsl:call-template name="xin">
			<xsl:with-param name="index" select="2 * position()"/>
			<xsl:with-param name="userdefined" select="''"/>
		</xsl:call-template>
	</xsl:variable>
	<xsl:call-template name="pointer">
		<xsl:with-param name="x" select="$x"/>
		<xsl:with-param name="y" select="$down*$dh div 2"/>
		<xsl:with-param name="identabove" select="identifier"/>
		<xsl:with-param name="height" select="9*$dh"/>
	</xsl:call-template>
	<text font-size="{/*/font}pt" x="{$x}px" y="{$down*$dh div 2}px" text-anchor="middle" pointer-events="none">
		<xsl:value-of select="/*/current"/>
	</text>
	<xsl:variable name="id" select="identifier"/>
	<xsl:call-template name="box">
		<xsl:with-param name="x" select="$x"/>
		<xsl:with-param name="y" select="($down + 5)*$dh div 4"/>
		<xsl:with-param name="ident" select="identifier"/>
		<xsl:with-param name="content" 
				select="/*/augusta[$level]/alice[identifier=$id]/component[identifier=/*/current]/name"/>
		<xsl:with-param name="containingarea" select="''"/>
		<xsl:with-param name="style" select="$style"/>
		<xsl:with-param name="hasedge" select="false()"/>
		<xsl:with-param name="istyped" select="false()"/>
		<xsl:with-param name="hasarrow" select="''"/>
	</xsl:call-template>
</xsl:template>

<!-- component boxes -->
<xsl:template mode="boxinside" match="/*/augusta/alice"> 
	<xsl:param name="parentlevel"/>
	<xsl:param name="style"/>
	<xsl:variable name="id" select="identifier"/>
	<xsl:call-template name="box">
		<xsl:with-param name="x">
			<xsl:call-template name="xin">
				<xsl:with-param name="index" select="position()"/>
				<xsl:with-param name="userdefined" select="position[type=$style and identifier=/*/current]/x"/>
			</xsl:call-template>
		</xsl:with-param>
		<xsl:with-param name="y">
			<xsl:call-template name="yin">
				<xsl:with-param name="index" select="position()"/>
				<xsl:with-param name="userdefined" select="position[type=$style and identifier=/*/current]/y"/>
			</xsl:call-template>
		</xsl:with-param>
		<xsl:with-param name="ident" select="identifier"/>
		<xsl:with-param name="content" 
						select="/*/augusta[$parentlevel]/alice[identifier=/*/current]/component[identifier=$id]/name"/>
		<xsl:with-param name="containingarea" select="'frame'"/>
		<xsl:with-param name="style" select="$style"/>
		<xsl:with-param name="hasedge" select="true()"/>
		<xsl:with-param name="istyped" select="type!=''"/>
		<xsl:with-param name="hasarrow" select="''"/>
	</xsl:call-template>
</xsl:template>

<!-- component lines -->
<xsl:template mode="lineinside" match="/*/augusta/alice"> 
	<xsl:param name="x1"/>
	<xsl:param name="y1"/>
	<xsl:param name="i"/>
	<xsl:param name="parentlevel"/>
	<xsl:param name="style"/>
	<xsl:variable name="p" select="position()"/>
	<xsl:if test="position() > $i">
		<xsl:call-template name="line">
			<xsl:with-param name="x1" select="$x1"/>
			<xsl:with-param name="y1" select="$y1"/>
			<xsl:with-param name="x2">
				<xsl:call-template name="xin">
					<xsl:with-param name="index" select="$p"/>
					<xsl:with-param name="userdefined" select="position[type=$style and identifier=/*/current]/x"/>
				</xsl:call-template>
			</xsl:with-param>
			<xsl:with-param name="y2">
				<xsl:call-template name="yin">
					<xsl:with-param name="index" select="$p"/>
					<xsl:with-param name="userdefined" select="position[type=$style and identifier=/*/current]/y"/>
				</xsl:call-template>
			</xsl:with-param>
			<xsl:with-param name="ident1" 
								select="/*/augusta[$parentlevel]/alice[composite/identifier=/*/current][$i]/identifier"/>
			<xsl:with-param name="ident2" 
								select="/*/augusta[$parentlevel]/alice[composite/identifier=/*/current][$p]/identifier"/>
			<xsl:with-param name="level" select="$parentlevel + 1"/>
		</xsl:call-template>
	</xsl:if>
</xsl:template>

<!-- one box with decorations - start -->
<xsl:template name="box">
	<xsl:param name="x"/>
	<xsl:param name="y"/>
	<xsl:param name="ident"/>
	<xsl:param name="content"/>
	<xsl:param name="containingarea"/>
	<xsl:param name="style"/>
	<xsl:param name="hasedge"/>
	<xsl:param name="istyped"/>
	<xsl:param name="hasarrow"/>
	<xsl:variable name="paddedcontent">
		<xsl:choose>
			<xsl:when test="$content=''"><xsl:value-of select="'?'"/></xsl:when>	
			<xsl:otherwise><xsl:value-of select="$content"/></xsl:otherwise>
		</xsl:choose>						
	</xsl:variable>
	<xsl:variable name="linedcontent">
		<xsl:call-template name="splittext">
			<xsl:with-param name="startcontent" select="$paddedcontent"/>
			<xsl:with-param name="endcontent" select="''"/>
			<xsl:with-param name="currentlinelength" select="0"/>
		</xsl:call-template>
	</xsl:variable>
	<xsl:variable name="linecount">
		<xsl:call-template name="counttextlines">
			<xsl:with-param name="content" select="$linedcontent"/>
			<xsl:with-param name="linecount" select="1"/>
		</xsl:call-template>
	</xsl:variable>
	<xsl:call-template name="decoration">
		<xsl:with-param name="x" select="$x"/>
		<xsl:with-param name="y" select="$y"/>
		<xsl:with-param name="hasedge" select="$hasedge"/>
		<xsl:with-param name="hasarrow" select="$hasarrow"/>
		<xsl:with-param name="linecount" select="$linecount"/>
		<xsl:with-param name="ident" select="$ident"/>
		<xsl:with-param name="identabove" select="composite/identifier"/>
	</xsl:call-template>
	<xsl:call-template name="rectangle">
		<xsl:with-param name="x" select="$x"/>
		<xsl:with-param name="y" select="$y"/>
		<xsl:with-param name="ident" select="$ident"/>
		<xsl:with-param name="contentlength" select="string-length($linedcontent) + 1"/>
		<xsl:with-param name="depth" select="$linecount * /*/font"/>
		<xsl:with-param name="hasedge" select="$hasedge"/>
		<xsl:with-param name="istyped" select="$istyped"/>
		<xsl:with-param name="containingarea" select="$containingarea"/>
		<xsl:with-param name="style" select="$style"/>
	</xsl:call-template>
	<xsl:call-template name="textlines">
		<xsl:with-param name="x" select="$x"/>
		<xsl:with-param name="y" select="$y - ($linecount - 1) * /*/font"/>
		<xsl:with-param name="content" select="$linedcontent"/>
		<xsl:with-param name="ident" select="$ident"/>
		<xsl:with-param name="containingarea" select="$containingarea"/>
		<xsl:with-param name="style" select="$style"/>
		<xsl:with-param name="hasedge" select="$hasedge"/>
	</xsl:call-template>
</xsl:template>

<!-- text split into lines of right length with *s-->
<xsl:template name="splittext"> 
	<xsl:param name="startcontent"/>
	<xsl:param name="endcontent"/>
	<xsl:param name="currentlinelength"/>
	<xsl:variable name="front" select="substring-before($startcontent, ' ')"/>
	<xsl:variable name="frontlength" select="string-length($front)"/>
	<xsl:choose>
		<xsl:when test="$frontlength=0 and starts-with($startcontent, ' ')">
			<xsl:call-template name="splittext">
				<xsl:with-param name="startcontent" select="substring($startcontent, 2)"/>
				<xsl:with-param name="endcontent" select="$endcontent"/>
				<xsl:with-param name="currentlinelength" select="$currentlinelength"/>
			</xsl:call-template>
		</xsl:when>
		<xsl:when test="$frontlength=0 and string-length($startcontent) + $currentlinelength + 1 > /*/textx">
			<xsl:value-of select="concat($endcontent, '*', $startcontent)"/>
		</xsl:when>
		<xsl:when test="$frontlength=0 and /*/textx > string-length($startcontent) + $currentlinelength + 1">
			<xsl:value-of select="concat($endcontent, ' ', $startcontent)"/>
		</xsl:when>
		<xsl:when test="/*/textx > $frontlength + $currentlinelength">
			<xsl:call-template name="splittext">
				<xsl:with-param name="startcontent" select="substring-after($startcontent, ' ')"/>
				<xsl:with-param name="endcontent" select="concat($endcontent, ' ', $front)"/>
				<xsl:with-param name="currentlinelength" select="$currentlinelength + 1 + $frontlength"/>
			</xsl:call-template>
		</xsl:when>
		<xsl:otherwise>
			<xsl:call-template name="splittext">
				<xsl:with-param name="startcontent" select="$startcontent"/>
				<xsl:with-param name="endcontent" select="concat($endcontent, '*')"/>
				<xsl:with-param name="currentlinelength" select="0"/>
			</xsl:call-template>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<!-- count of text lines separated by *s -->
<xsl:template name="counttextlines"> 
	<xsl:param name="content"/>
	<xsl:param name="linecount"/>
	<xsl:choose>
		<xsl:when test="substring-before($content, '*') = ''">
			<xsl:value-of select="$linecount"/>
		</xsl:when>
		<xsl:otherwise>
			<xsl:call-template name="counttextlines">
				<xsl:with-param name="content" select="substring-after($content, '*')"/>
				<xsl:with-param name="linecount" select="$linecount + 1"/>
			</xsl:call-template>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<!-- decoration above box -->
<xsl:template name="decoration"> 
	<xsl:param name="x"/>
	<xsl:param name="y"/>
	<xsl:param name="hasedge"/>
	<xsl:param name="hasarrow"/>
	<xsl:param name="linecount"/>
	<xsl:param name="ident"/>
	<xsl:param name="identabove"/>
	<xsl:variable name="linkstart" select="concat(/*/logical, /*/width, '-', /*/height, '-')"/>
	<xsl:variable name="link" 
			select="concat($linkstart, /*/user, '|', /*/database, '-sets-current|left|right-', $ident, '|',
		/*/augusta/alice[identifier=$ident]/composite[1]/identifier, '|', 
		/*/augusta/alice[identifier=$ident]/composite[2]/identifier, '-', /*/counter)"/>
	<xsl:variable name="yminus" select="$y - (4 * $linecount + 1) * /*/font div 4"/>
	<xsl:if test="$hasedge">
		<xsl:if test="$hasarrow != ''">
			<xsl:call-template name="pointer">
				<xsl:with-param name="x" select="$x"/>
				<xsl:with-param name="y" select="$y - $linecount * /*/font"/>
				<xsl:with-param name="identabove" select="$identabove"/>
				<xsl:with-param name="height" select="3 * /*/font"/>
			</xsl:call-template>
		</xsl:if>
		<text font-size="{/*/font}pt" x="{$x}px" y="{$yminus}px" text-anchor="middle" 
				stroke="{/*/linkcolor}">
			<a xlink:href="{$link}"><xsl:value-of select="$ident"/></a>
		</text>
	</xsl:if>
</xsl:template>

<!-- the rectangle -->
<xsl:template name="rectangle"> 
	<xsl:param name="x"/>
	<xsl:param name="y"/>
	<xsl:param name="ident"/>
	<xsl:param name="contentlength"/>
	<xsl:param name="depth"/>
	<xsl:param name="hasedge"/>
	<xsl:param name="istyped"/>
	<xsl:param name="containingarea"/>
	<xsl:param name="style"/>
	<xsl:variable name="linkstart" select="concat(/*/logical, /*/width, '-', /*/height, '-')"/>
	<xsl:variable name="movelink" select="concat($linkstart, /*/user, '|', /*/database, '-')"/>
	<xsl:variable name="boxwidth">
		<xsl:call-template name="minimum">
			<xsl:with-param name="first" select="/*/textx * /*/font div 10"/>
			<xsl:with-param name="second" select="$contentlength * /*/font div 10"/>
		</xsl:call-template>
	</xsl:variable>
	<rect x="{$x - (/*/scaling div 2) * $boxwidth}px" y="{$y - $depth}px" 
			width="{(/*/scaling) * $boxwidth}px" height="{2 * $depth}px" 
			fill="{/*/backcolor}" rx="{/*/rx * /*/scaling * $boxwidth div 10}" ry="{/*/ry * 2 * $depth div 10}"
			onmouseup
				="document.getElementById('{$containingarea}').style.setProperty('pointer-events', 'none'); 
					copymoveorlink = moveorlink; moveorlink = '';
					if (copymoveorlink != 'link' || id != '{$ident}')
					{{	parent.open('{$movelink}' + copymoveorlink + '-{$style}|' + id + '|' + '{$ident}' 
									+ '|' + evt.clientX  + '|' + evt.clientY + namerequest + {/*/counter}, 'posd'); 
					}};"
			onmousedown
				="if (moveorlink == '') 
				  {{ document.getElementById('{$containingarea}').style.setProperty('pointer-events', 'all');
					 id='{$ident}'; namerequest = '-z_name_-'; moveorlink = 'link';
				  }}">
		<xsl:attribute name="stroke">
			<xsl:choose>
				<xsl:when test="$hasedge and $istyped"><xsl:value-of select="/*/typedcolor"/></xsl:when>
				<xsl:when test="$hasedge"><xsl:value-of select="/*/linecolor"/></xsl:when>
				<xsl:otherwise><xsl:value-of select="none"/></xsl:otherwise>
			</xsl:choose>
		</xsl:attribute>
	</rect>
</xsl:template>

<!-- text lines separated by *s -->
<xsl:template name="textlines"> 
	<xsl:param name="x"/>
	<xsl:param name="y"/>
	<xsl:param name="content"/>
	<xsl:param name="ident"/>
	<xsl:param name="containingarea"/>
	<xsl:param name="style"/>
	<xsl:param name="hasedge"/>
	<xsl:variable name="yplus" select="$y + /*/font div 2"/>
	<xsl:choose>
		<xsl:when test="substring-before($content, '*')!='' or substring($content, 1, 1)='*'">
			<xsl:call-template name="textline">
				<xsl:with-param name="x" select="$x"/>
				<xsl:with-param name="y" select="$yplus"/>
				<xsl:with-param name="content" select="substring-before($content, '*')"/>
				<xsl:with-param name="ident" select="$ident"/>
				<xsl:with-param name="containingarea" select="$containingarea"/>
				<xsl:with-param name="style" select="$style"/>
				<xsl:with-param name="hasedge" select="$hasedge"/>
			</xsl:call-template>
			<xsl:call-template name="textlines">
				<xsl:with-param name="x" select="$x"/>
				<xsl:with-param name="y" select="$y + 2 * /*/font"/>
				<xsl:with-param name="content" select="substring-after($content, '*')"/>
				<xsl:with-param name="ident" select="$ident"/>
				<xsl:with-param name="containingarea" select="$containingarea"/>
				<xsl:with-param name="style" select="$style"/>
				<xsl:with-param name="hasedge" select="$hasedge"/>
			</xsl:call-template>
		</xsl:when>
		<xsl:otherwise>
			<xsl:call-template name="textline">
				<xsl:with-param name="x" select="$x"/>
				<xsl:with-param name="y" select="$yplus"/>
				<xsl:with-param name="content" select="$content"/>
				<xsl:with-param name="ident" select="$ident"/>
				<xsl:with-param name="containingarea" select="$containingarea"/>
				<xsl:with-param name="style" select="$style"/>
				<xsl:with-param name="hasedge" select="$hasedge"/>
			</xsl:call-template>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<!-- one of the text lines -->
<xsl:template name="textline">
	<xsl:param name="x"/>
	<xsl:param name="y"/>
	<xsl:param name="content"/>
	<xsl:param name="ident"/>
	<xsl:param name="containingarea"/>
	<xsl:param name="style"/>
	<xsl:param name="hasedge"/>
	<xsl:variable name="linkstart" select="concat(/*/logical, /*/width, '-', /*/height, '-')"/>
	<xsl:variable name="movelink" select="concat($linkstart, /*/user, '|', /*/database, '-')"/>
	<xsl:choose>
		<xsl:when test="$hasedge">
			<text font-size="{/*/font}pt" x="{$x}px" y="{$y}px" text-anchor="middle" stroke="{/*/fontcolor}"
					onmouseup
						="document.getElementById('{$containingarea}').style.setProperty('pointer-events', 'none'); 
							copymoveorlink = moveorlink; moveorlink = '';
							if (copymoveorlink != 'link' || id != '{$ident}')
							{{	parent.open('{$movelink}' + copymoveorlink + '-{$style}|' + id + '|' + '{$ident}' 
									+ '|' + evt.clientX  + '|' + evt.clientY + namerequest + {/*/counter}, 'posd');
							}};"
					onmousedown
						="if (moveorlink == '') 
							{{ document.getElementById('{$containingarea}').style.setProperty('pointer-events', 'all');
								id='{$ident}'; namerequest = '--'; moveorlink = 'move';
							}};">
				<xsl:value-of select="$content"/>
			</text>
		</xsl:when>
		<xsl:otherwise>
			<text font-size="{/*/font}pt" x="{$x}px" y="{$y}px" text-anchor="middle" 
					stroke="{/*/fontcolor}" pointer-events="none">
				<xsl:value-of select="$content"/>
			</text>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<!-- one box with decorations - end -->





<!-- shared capabilities -->
<!-- one line with decorations - start -->
<xsl:template name="line">
	<xsl:param name="x1"/>
	<xsl:param name="y1"/>
	<xsl:param name="x2"/>
	<xsl:param name="y2"/>
	<xsl:param name="ident1"/>
	<xsl:param name="ident2"/>
	<xsl:param name="level"/>
	<xsl:variable name="annotationlist" select="
				/*/augusta[position() &gt;= $level]/alice
				[(identifier=$ident1 and composite/identifier=$ident2) 
						or (identifier=$ident2 and composite/identifier=$ident1)
						or (composite/identifier=$ident1 and composite/identifier=$ident2)]"/>
	<xsl:variable name="ordering">
		<xsl:choose>
			<xsl:when test="$x2 > $x1"><xsl:value-of select="'-current|left|right-'"/></xsl:when>	
			<xsl:otherwise><xsl:value-of select="'-current|right|left-'"/></xsl:otherwise>
		</xsl:choose>						
	</xsl:variable>
	<xsl:variable name="identifiersoflines">
		<xsl:apply-templates mode="lineidentifiers" select="$annotationlist">
			<xsl:with-param name="id1" select="$ident1"/>
			<xsl:with-param name="id2" select="$ident2"/>
			<xsl:with-param name="ordering" select="$ordering"/>
		</xsl:apply-templates>	
	</xsl:variable>
	<xsl:variable name="namesoflines">
		<xsl:apply-templates mode="linenames" select="$annotationlist">
			<xsl:with-param name="id1" select="$ident1"/>
			<xsl:with-param name="id2" select="$ident2"/>
		</xsl:apply-templates>	
	</xsl:variable>
	<xsl:if test="$identifiersoflines!=''">	
		<xsl:call-template name="lineplus">
			<xsl:with-param name="x1" select="$x1"/>
			<xsl:with-param name="y1" select="$y1"/>
			<xsl:with-param name="x2" select="$x2"/>
			<xsl:with-param name="y2" select="$y2"/>
			<xsl:with-param name="id1" select="$ident1"/>
			<xsl:with-param name="id2" select="$ident2"/>
			<xsl:with-param name="ordering" select="$ordering"/>
			<xsl:with-param name="identifiers" select="$identifiersoflines"/>
			<xsl:with-param name="names" select="$namesoflines"/>
		</xsl:call-template>
	</xsl:if>
</xsl:template>
<!-- find identifier of another component shared by systems at end of a line -->
<xsl:template mode="lineidentifiers" match="/*/augusta/alice"> 
	<xsl:param name="id1"/>
	<xsl:param name="id2"/>
	<xsl:param name="ordering"/>
	<xsl:variable name="linkstart" select="concat(/*/logical, /*/width, '-', /*/height, '-')"/>
	<xsl:variable name="link" select="concat($linkstart, /*/user, '|', /*/database, '-sets', 
														$ordering, identifier, '|', $id1, '|', $id2, '-', /*/counter)"/>
	<a xlink:href="{$link}"><xsl:value-of select="concat(identifier, ' : ')"/></a>
</xsl:template>
<!-- find identifier of another component shared by systems at end of a line -->
<xsl:template mode="linenames" match="/*/augusta/alice"> 
	<xsl:param name="id1"/>
	<xsl:param name="id2"/>
	<xsl:variable name="id" select="identifier"/>
	<xsl:if test="/*/augusta/alice[identifier=$id1]/component[identifier=$id]/name != '' and
				  /*/augusta/alice[identifier=$id2]/component[identifier=$id]/name != ''">
		<xsl:if test="/*/augusta/alice[identifier=$id1]/component[identifier=$id]/name != ''">
			<xsl:value-of select="concat(' : ', /*/augusta/alice[identifier=$id1]/component[identifier=$id]/name)"/>
		</xsl:if>
		<xsl:if test="/*/augusta/alice[identifier=$id2]/component[identifier=$id]/name != '' and
					/*/augusta/alice[identifier=$id2]/component[identifier=$id]/name 
										!= /*/augusta/alice[identifier=$id1]/component[identifier=$id]/name">
			<xsl:value-of select="concat(' : ', /*/augusta/alice[identifier=$id2]/component[identifier=$id]/name)"/>
		</xsl:if>
	</xsl:if>
	<xsl:value-of select="' * '"/>
</xsl:template>
<!-- one line with text optionally displayed on it near one end -->
<xsl:template name="lineplus">
	<xsl:param name="x1"/>
	<xsl:param name="y1"/>
	<xsl:param name="x2"/>
	<xsl:param name="y2"/>
	<xsl:param name="id1"/>
	<xsl:param name="id2"/>
	<xsl:param name="ordering"/>
	<xsl:param name="identifiers"/>
	<xsl:param name="names"/>
	<xsl:variable name="linename" select="concat($x1, 'x', $y1, 'x', $x2, 'x', $y2)"/>
	<path id="line{$linename}" stroke="{/*/linecolor}" d="M {$x1} {$y1} {$x2} {$y2}" pointer-events="none"/>
	<xsl:variable name="transform">
		<xsl:choose>
			<xsl:when test="$x1 >= $x2">
				<xsl:value-of select="concat('rotate(180,', ($x1 + $x2) div 2, ', ', ($y1 + $y2) div 2, ')')"/>
			</xsl:when>
			<xsl:otherwise><xsl:value-of select="''"/></xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:if test="/*/lineannotation='identifiers'">
		<text font-size="{/*/font}pt" text-anchor="middle" stroke="{/*/linkcolor}" 
				transform="{$transform}"> 
			<textPath xlink:href="#line{$linename}" startOffset="50%"><xsl:copy-of select="$identifiers"/></textPath>
		</text>
	</xsl:if>
	<xsl:if test="/*/lineannotation='both'">
		<xsl:call-template name="nameofline">
			<xsl:with-param name="transform" select="$transform"/>
			<xsl:with-param name="pathname" select="concat('#line', $linename)"/>
			<xsl:with-param name="names" select="$names"/>
			<xsl:with-param name="id1" select="$id1"/>
			<xsl:with-param name="id2" select="$id2"/>
			<xsl:with-param name="ordering" select="$ordering"/>
			<xsl:with-param name="identifiers" select="$identifiers"/>
			<xsl:with-param name="direction">
				<xsl:choose>
					<xsl:when test="($x1 - $x2) * ($y1 - $y2) > 0"><xsl:value-of select="-1"/></xsl:when>
					<xsl:otherwise><xsl:value-of select="1"/></xsl:otherwise>
				</xsl:choose>
			</xsl:with-param>
			<xsl:with-param name="counter" select="0"/>
		</xsl:call-template>
	</xsl:if>
</xsl:template>
<!-- one line of text optionally -->
<xsl:template name="nameofline">
	<xsl:param name="transform"/>
	<xsl:param name="pathname"/>
	<xsl:param name="names"/>
	<xsl:param name="id1"/>
	<xsl:param name="id2"/>
	<xsl:param name="ordering"/>
	<xsl:param name="identifiers"/>
	<xsl:param name="direction"/>
	<xsl:param name="counter"/>
	<xsl:variable name="delta">
		<xsl:choose>
			<xsl:when test="$transform = ''"><xsl:value-of select="-(5 * $counter) * /*/font div 4"/></xsl:when>
			<xsl:otherwise><xsl:value-of select="(5 * $counter) * /*/font div 4"/></xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="namefront" select="substring-before($names, ' * ')"/>
	<xsl:variable name="nameback" select="substring-after($names, ' * ')"/>
	<xsl:variable name="identfront" select="substring-before($identifiers, ' : ')"/>
	<xsl:variable name="identback" select="substring-after($identifiers, ' : ')"/>
	<xsl:variable name="linkstart" select="concat(/*/logical, /*/width, '-', /*/height, '-')"/>
	<xsl:variable name="link" select="concat($linkstart, /*/user, '|', /*/database, '-sets', 
																$ordering, $identfront, '|', $id1, '|', $id2, '-')"/>
	<text font-size="{/*/font}pt" text-anchor="middle" stroke="{/*/fontcolor}"
					transform="{concat($transform, 'translate(', ($delta * $direction), ',', $delta, ')')}"> 
		<textPath xlink:href="{$pathname}" startOffset="50%">
			<text font-size="{/*/font}pt" stroke="{/*/linkcolor}">
				<a xlink:href="{$link}"><xsl:copy-of select="$identfront"/></a>
			</text>
			<xsl:copy-of select="' '"/>
			<xsl:copy-of select="$namefront"/>
		</textPath>
	</text>
	<xsl:if test="$nameback != ''">
		<xsl:call-template name="nameofline">
			<xsl:with-param name="transform" select="$transform"/>
			<xsl:with-param name="pathname" select="$pathname"/>
			<xsl:with-param name="names" select="$nameback"/>
			<xsl:with-param name="id1" select="$id1"/>
			<xsl:with-param name="id2" select="$id2"/>
			<xsl:with-param name="ordering" select="$ordering"/>
			<xsl:with-param name="identifiers" select="$identback"/>
			<xsl:with-param name="direction" select="$direction"/>
			<xsl:with-param name="counter">
				<xsl:choose>
					<xsl:when test="$counter > -1"><xsl:value-of select="- $counter - 1"/></xsl:when>
					<xsl:otherwise><xsl:value-of select="- $counter"/></xsl:otherwise>
				</xsl:choose>
			</xsl:with-param>
		</xsl:call-template>
	</xsl:if>
</xsl:template>

<!-- one line with decorations - end -->





<!-- shared capabilities -->
<!-- widely used subroutines - start -->
<!-- minimum subroutine -->
<xsl:template name="minimum">
	<xsl:param name="first"/>
	<xsl:param name="second"/>
	<xsl:choose>
		<xsl:when test="$first > $second"><xsl:value-of select="$second"/></xsl:when>
		<xsl:otherwise><xsl:value-of select="$first"/></xsl:otherwise>
	</xsl:choose>
</xsl:template>

<!-- pointer on top of box subroutine -->
<xsl:template name="pointer">
	<xsl:param name="x"/>
	<xsl:param name="y"/>
	<xsl:param name="identabove"/>
	<xsl:param name="height"/>
	<xsl:variable name="f" select="/*/font"/>
	<xsl:variable name="linkstart" select="concat(/*/logical, /*/width, '-', /*/height, '-')"/>
	<xsl:variable name="link" 
			select="concat($linkstart, /*/user, '|', /*/database, '-sets-current|left|right-', $identabove, '|',
		/*/augusta/alice[identifier=$identabove]/composite[1]/identifier, '|', 
		/*/augusta/alice[identifier=$identabove]/composite[2]/identifier, '-', /*/counter)"/>
	<text font-size="{$f}pt" x="{$x}px" y="{$y - $height - $f}px" text-anchor="middle" 
			stroke="{/*/linkcolor}">
		<a xlink:href="{$link}"><xsl:value-of select="$identabove"/></a>
	</text>
	<line x1="{$x}px" y1="{$y - $height - $f}px" x2="{$x - $f div 2}px" y2="{$y - $height}px" 
		stroke="{/*/linecolor}" pointer-events="none"/>
	<line x1="{$x}px" y1="{$y - $f}px" x2="{$x}px" y2="{$y - $height - $f}px" 
		stroke="{/*/linecolor}" pointer-events="none"/>
	<line x1="{$x}px" y1="{$y - $height - $f}px" x2="{$x + $f div 2}px" y2="{$y - $height}px" 
		stroke="{/*/linecolor}" pointer-events="none"/>
</xsl:template>

<!-- widely used subroutines - end -->





<!-- shared capabilities -->
<!-- widely used variables - start -->
<xsl:template name="xin">
	<xsl:param name="index"/>
	<xsl:param name="userdefined"/>
	<xsl:variable name="dw" select="/*/width div 100"/>
	<xsl:choose>
		<xsl:when test="$userdefined"><xsl:value-of select="$userdefined"/></xsl:when>
		<xsl:when test="$index=1 or $index=2"><xsl:value-of select="50*$dw"/></xsl:when>
		<xsl:when test="$index=3 or $index=4"><xsl:value-of select="38*$dw"/></xsl:when>
		<xsl:when test="$index=5 or $index=6"><xsl:value-of select="62*$dw"/></xsl:when>
		<xsl:when test="$index=7 or $index=8"><xsl:value-of select="42*$dw"/></xsl:when>
		<xsl:when test="$index=9 or $index=10"><xsl:value-of select="58*$dw"/></xsl:when>
		<xsl:when test="$index=11 or $index=12"><xsl:value-of select="46*$dw"/></xsl:when>
		<xsl:when test="$index=13 or $index=14"><xsl:value-of select="54*$dw"/></xsl:when>
		<xsl:when test="$index=15"><xsl:value-of select="34*$dw"/></xsl:when>
		<xsl:when test="$index=16"><xsl:value-of select="66*$dw"/></xsl:when>
		<xsl:otherwise><xsl:value-of select="42*$dw"/></xsl:otherwise>
	</xsl:choose>
</xsl:template>
<xsl:template name="yin">
	<xsl:param name="index"/>
	<xsl:param name="userdefined"/>
	<xsl:variable name="dh" select="/*/height div 100"/>
	<xsl:choose>
		<xsl:when test="$userdefined"><xsl:value-of select="$userdefined"/></xsl:when>
		<xsl:when test="$index=1"><xsl:value-of select="18*$dh"/></xsl:when>
		<xsl:when test="$index=2"><xsl:value-of select="90*$dh"/></xsl:when>
		<xsl:when test="$index=3 or $index=5"><xsl:value-of select="27*$dh"/></xsl:when>
		<xsl:when test="$index=4 or $index=6"><xsl:value-of select="81*$dh"/></xsl:when>
		<xsl:when test="$index=7 or $index=9"><xsl:value-of select="36*$dh"/></xsl:when>
		<xsl:when test="$index=8 or $index=10"><xsl:value-of select="72*$dh"/></xsl:when>
		<xsl:when test="$index=11 or $index=13"><xsl:value-of select="45*$dh"/></xsl:when>
		<xsl:when test="$index=12 or $index=14"><xsl:value-of select="63*$dh"/></xsl:when>
		<xsl:when test="$index=15 or $index=16"><xsl:value-of select="54*$dh"/></xsl:when>
		<xsl:otherwise><xsl:value-of select="($index + 1)*18*$dh"/></xsl:otherwise>
	</xsl:choose>
</xsl:template>
<xsl:template name="xout">
	<xsl:param name="index"/>
	<xsl:param name="userdefined"/>
	<xsl:variable name="dw" select="/*/width div 100"/>
	<xsl:choose>
		<xsl:when test="$userdefined"><xsl:value-of select="$userdefined"/></xsl:when>
		<xsl:when test="$index mod 2 = 0"><xsl:value-of select="90*$dw"/></xsl:when>
		<xsl:when test="$index mod 2 = 1"><xsl:value-of select="10*$dw"/></xsl:when>
	</xsl:choose>
</xsl:template>
<xsl:template name="yout">
	<xsl:param name="index"/>
	<xsl:param name="userdefined"/>
	<xsl:variable name="dh" select="/*/height div 100"/>
	<xsl:choose>
		<xsl:when test="$userdefined"><xsl:value-of select="$userdefined"/></xsl:when>
		<xsl:when test="$index=1 or $index=2"><xsl:value-of select="54*$dh"/></xsl:when>
		<xsl:when test="$index=3 or $index=4"><xsl:value-of select="18*$dh"/></xsl:when>
		<xsl:when test="$index=5 or $index=6"><xsl:value-of select="90*$dh"/></xsl:when>
		<xsl:when test="$index=7 or $index=8"><xsl:value-of select="36*$dh"/></xsl:when>
		<xsl:when test="$index=9 or $index=10"><xsl:value-of select="72*$dh"/></xsl:when>
		<xsl:when test="$index=11 or $index=12"><xsl:value-of select="27*$dh"/></xsl:when>
		<xsl:when test="$index=13 or $index=14"><xsl:value-of select="81*$dh"/></xsl:when>
		<xsl:when test="$index=15 or $index=16"><xsl:value-of select="45*$dh"/></xsl:when>
		<xsl:when test="$index=17 or $index=18"><xsl:value-of select="63*$dh"/></xsl:when>
		<xsl:otherwise><xsl:value-of select="46*$dw"/></xsl:otherwise>
	</xsl:choose>
</xsl:template>

<!-- widely used variables - end -->





</xsl:transform>
